<?php

function ReqSqlIp($id)
{
include("config.php");
try
{
	$pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
	$bdd = new PDO("mysql:host=$dbhost;dbname=$dbbase", $dbuser, $bdpass, $pdo_options);

	$req = $bdd->prepare('SELECT ip, name FROM equipements where id = ?');
	$req->execute(array($id));
	while ($donnees = $req->fetch())
	{
	$ip = $donnees['ip'];
	$name =  $donnees['name'];
	}
	$req->closeCursor();
	return $ip;
}
catch(Exception $e)
{
    die('Erreur : '.$e->getMessage());
}
}

//////////////////////////////////////////////////////

function ReqSqlName($id)
{
include("config.php");

try
{
	$pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
	$bdd = new PDO("mysql:host=$dbhost;dbname=$dbbase", $dbuser, $bdpass, $pdo_options);

	$req = $bdd->prepare('SELECT ip, name FROM equipements where id = ?');
	$req->execute(array($id));
	while ($donnees = $req->fetch())
	{
	$name =  $donnees['name'];
	}
	$req->closeCursor();
	return $name;
}
catch(Exception $e)
{
    die('Erreur : '.$e->getMessage());
}
}
//////////////////////////////////////////////////////

function ReqSqlModel($id)
{
include("config.php");

try
{
	$pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
	$bdd = new PDO("mysql:host=$dbhost;dbname=$dbbase", $dbuser, $bdpass, $pdo_options);

	$req = $bdd->prepare('SELECT model FROM equipements where id = ?');
	$req->execute(array($id));
	while ($donnees = $req->fetch())
	{
	$model =  $donnees['model'];
	}
	$req->closeCursor();
	return $model;
}
catch(Exception $e)
{
    die('Erreur : '.$e->getMessage());
}
}

//////////////////////////////////////////////////////

function ReqSqlInterco($id, $interface_des)
{
include("config.php");

try
{
	$pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
	$bdd = new PDO("mysql:host=$dbhost;dbname=$dbbase", $dbuser, $bdpass, $pdo_options);

	$req = $bdd->prepare('SELECT * FROM interco where idequipement = ? and interface_des = ?');
	$req->execute(array($id, $interface_des));

	if ($req->rowCount() > 0)//test si le nbr de lignes renvoye par la requête sql est sup à 0
	{
	return 1;
	}
	else
	{
	return 0;
	}
	$req->closeCursor();
}
catch(Exception $e)
{
    die('Erreur : '.$e->getMessage());
}
}

//////////////////////////////////////////////////////

function InsertSqlInterco($id, $interface_des)
{
include("config.php");

try
{
	$pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
	$bdd = new PDO("mysql:host=$dbhost;dbname=$dbbase", $dbuser, $bdpass, $pdo_options);

	$req = $bdd->prepare('INSERT INTO interco (idequipement, interface_des) VALUES(?,?)');
	$req->execute(array($id, $interface_des));

	$req->closeCursor();
}
catch(Exception $e)
{
    die('Erreur : '.$e->getMessage());
}
}


//////////////////////////////////////////////////////

function DeleteSqlInterco($id, $interface_des)
{
include("config.php");

try
{
	$pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
	$bdd = new PDO("mysql:host=$dbhost;dbname=$dbbase", $dbuser, $bdpass, $pdo_options);

	$req = $bdd->prepare('DELETE FROM interco where idequipement = ? and interface_des = ?');
	$req->execute(array($id, $interface_des));

	$req->closeCursor();
}
catch(Exception $e)
{
    die('Erreur : '.$e->getMessage());
}
}


//////////////////////////////////////////////////////

function InsertSqlMacPortEqui($id,$interface_port,$interface_mac)
{
include("config.php");

try
{
	$pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
	$bdd = new PDO("mysql:host=$dbhost;dbname=$dbbase", $dbuser, $bdpass, $pdo_options);

	$req = $bdd->prepare('INSERT INTO  macport (idequip, port, mac) VALUES(?,?,?)');
	$req->execute(array($id, $interface_port, $interface_mac));
	$req->closeCursor();

	$req2 = $bdd->prepare('SELECT * FROM macporthistory where idequip = ? and port = ? and mac = ?');
	$req2->execute(array($id, $interface_port, $interface_mac));

	if ($req2->rowCount() > 0)
	{
	$req = $bdd->prepare('UPDATE macporthistory SET date = NOW() where idequip = ? and port = ? and mac = ?');
	$req->execute(array($id, $interface_port, $interface_mac));
	$req->closeCursor();
	}
	else
	{
	$req = $bdd->prepare('INSERT INTO  macporthistory (idequip, port, mac, date) VALUES(?,?,?,NOW())');
	$req->execute(array($id, $interface_port, $interface_mac));
	$req->closeCursor();
	}
	$req2->closeCursor();
}
catch(Exception $e)
{
	die('Erreur : '.$e->getMessage());
}
}

//////////////////////////////////////////////////////

function DeletSqlMacPortEqui($id)
{
include("config.php");

try
{
	$pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
	$bdd = new PDO("mysql:host=$dbhost;dbname=$dbbase", $dbuser, $bdpass, $pdo_options);

	$req = $bdd->prepare('DELETE FROM macport where idequip = ?');
	$req->execute(array($id));
	$req->closeCursor();

}
catch(Exception $e)
{
    die('Erreur : '.$e->getMessage());
}
}

//////////////////////////////////////////////////////

function ReqSqlIpIdEqui()
{
include("config.php");

try
{
	$pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
	$bdd = new PDO("mysql:host=$dbhost;dbname=$dbbase", $dbuser, $bdpass, $pdo_options);
	$id = 15;
	$req = $bdd->prepare('SELECT id, ip, name, status from equipements');
	$req->execute();
	$equi = array();
	$i = 0;
	while ($donnees = $req->fetch())
	{
	$equip[$i]['id'] = $donnees['id'];
	$equip[$i]['ip'] = $donnees['ip'];
	$equip[$i]['name'] = $donnees['name'];
	$equip[$i]['status'] = $donnees['status'];
	$i++;
	}
	$req->closeCursor();
	return $equip;
}
catch(Exception $e)
{
    die('Erreur : '.$e->getMessage());
}

}

//////////////////////////////////////////////////////

function NbrEquip()
{
include("config.php");

try
{
	$pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
	$bdd = new PDO("mysql:host=$dbhost;dbname=$dbbase", $dbuser, $bdpass, $pdo_options);

	$req = $bdd->query('SELECT * FROM equipements');

	$nbr = $req->rowCount();
	return $nbr;
}
catch(Exception $e)
{
    die('Erreur : '.$e->getMessage());
}

}


//////////////////////////////////////////////////////

function VerifAbonnementMac($mac)
{
include("config.php");

try
{
	$pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
	$bdd = new PDO("mysql:host=$dbhost;dbname=$dbbase", $dbuser, $bdpass, $pdo_options);

	
	$req = $bdd->prepare('SELECT * from abonnements WHERE mac = ?');
	$req->execute(array($mac));
	if ($req->rowCount() > 0)//test si le nbr de lignes renvoye par la requête sql est sup à 0
	{
	return 1;
	}
	else
	{
	return 0;
	}
}
catch(Exception $e)
{
    die('Erreur : '.$e->getMessage());
}

}

//////////////////////////////////////////////////////

function MailAbonnementMac($id,$port,$mac)
{
include("config.php");

$yearmonth = date("Y-m");
$day = date("d");
$date = $yearmonth . "-" . $day;
$day = $day  - 2;
$dateminus2 = $yearmonth . "-" . $day;


try
{
	$pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
	$bdd = new PDO("mysql:host=$dbhost;dbname=$dbbase", $dbuser, $bdpass, $pdo_options);

	
	$req = $bdd->prepare('SELECT id, mac, email from abonnements WHERE mac = ?');
	$req->execute(array($mac));
	while ($donnees = $req->fetch())
	{
	$req2 = $bdd->prepare('SELECT * from abonnementseventlog WHERE idabonnement = ? and idequipement = ? and port = ? and DATE(datetime) BETWEEN ? AND ?');
	$req2->execute(array($donnees['id'],$id,$port,$dateminus2,$date));

        if ($req2->rowCount() == 0)//test si le nbr de lignes renvoye par la requête sql est sup à 0
        {
	$req3 = $bdd->prepare('INSERT INTO abonnementseventlog (idabonnement, idequipement, port, datetime) VALUES(?,?,?,NOW())');
	$req3->execute(array($donnees['id'],$id,$port));
	$req3->closeCursor();
	SendMail($id,$port,$donnees['mac'],$donnees['email']);
	}

        }
        $req2->closeCursor();
	$req->closeCursor();

}
catch(Exception $e)
{
    die('Erreur : '.$e->getMessage());
}

}

//////////////////////////////////////////////////////

function SendMail($id,$port,$mac,$mail)
{
include("config.php");

	$ip = ReqSqlIp($id);
	$oiddes = "1.3.6.1.2.1.2.2.1.2." . $port;
	snmp_set_valueretrieval(SNMP_VALUE_PLAIN);//The return values will be the plain value without the SNMP type hint.
	$port = snmpget($ip, $comro, $oiddes); //NOM INTERFACE

$message = '
<html>
<head>
  <title>MAC</title>
</head>
<body>
<div align="center"> 

  <table style="background-color:#0000ff;" border="1">
    <tr style="border-color: #000000; background-color:#00a7ff;">
      <th>MAC</th><th>Switch</th><th>Port</th>
    </tr>
    <tr style="border-color: #000000; background-color:#00a7ff; text-align:center;">
      <td>' . $mac . '</td><td>' . ReqSqlName($id) . '</td><td>' . $port . '</td>
    </tr>
  </table>
</div>
</body>
</html>

';
$headers  = 'MIME-Version: 1.0' . "\r\n";
$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
$headers .= 'From: ' . $adminmail;

mail($mail,"Adresse Mac: " . $mac . " connecté sur le port " . $port . " de " . ReqSqlName($id) . ".", $message, $headers);

}

?>
